<template>
  <div style="width: 600px;">
    <div v-show="isAdd">
      <el-form label-width="100px">
        <el-form-item :label="$t('STUDENT_MENU.SUBMIT') + ' ' + $t('LECTURE_LIST.TYPE')">
          <el-radio-group v-model="questionType" @change="initialForm">
            <el-radio-button label="1">{{ $t('QUESTION.SHORT_ANS') }}</el-radio-button>
            <el-radio-button label="0">{{ $t('QUESTION.MULTI_ANS') }}</el-radio-button>
            <el-radio-button label="2">{{ $t('QUESTION.FILE') }}</el-radio-button>
          </el-radio-group>
        </el-form-item>
        <div v-show="questionType === null">
          <el-alert
            :title="$t('STUDENT_MENU.SUBMIT_TYPE_SLCT')"
            :closable="false"
            type="warning"
            show-icon center>
          </el-alert>
        </div>
        <div v-if="questionType !== null">
          <template v-if="questionType === '2'">
            <el-form-item :label="$t('BOARD.TITLE')">
              <el-input v-model="questionName" :placeholder="$t('QUESTION.ENTER_TITLE')"
              type="textarea" :autosize="{minRows: 2, maxRows: 3 }"></el-input>
            </el-form-item>
            <el-form-item :label="$t('HELP.EXPLANATION')">
              <el-input v-model="question" :placeholder="$t('NOTIFY.ENTER_CONTENTS')" 
              type="textarea" :autosize="{ minRows: 8, maxRows: 12 }"></el-input>
            </el-form-item>
          </template>
          <template v-else>
            <el-form-item :label="$t('BOARD.TITLE')">
              <el-input v-model="questionName" :placeholder="$t('NOTIFY.ENTER_CONTENTS')"
              type="textarea" :autosize="{minRows: 2, maxRows: 3 }"></el-input>
            </el-form-item>
            <el-form-item :label="$t('QUESTION.QUESTION')">
              <el-input v-model="question" :placeholder="$t('NOTIFY.ENTER_CONTENTS')" 
              type="textarea" :autosize="{ minRows: 8, maxRows: 12 }"></el-input>
            </el-form-item>
          </template>
      
        
          <template v-if="questionType === '1'">
            <el-form-item :label="$t('QUESTION.ANSWER')">
              <el-input v-model="answer[0]" :placeholder="$t('NOTIFY.ENTER_CONTENTS')" type="textarea"></el-input>
            </el-form-item>
          </template>
          <template v-else-if="questionType === '0'">
            <el-form-item :label="$t('QUESTION.CHOICE')">
              <el-checkbox-group v-model="answer" @change="handleAnswerListChange">
      
                <div v-for="n in 5" :key="n">
                  <el-checkbox :label="n">{{ n }}. </el-checkbox>
                  <span class="answer-list">
                  <el-input v-model="choice[n-1]" :placeholder="$t('NOTIFY.ENTER_CONTENTS')"  class="answer-list"></el-input>
                  </span>
                </div>
      
              </el-checkbox-group>
            </el-form-item>
          </template>
          <template v-if="questionType !== '2'">
            <el-form-item :label="$t('QUESTION.LEVEL')">
              <el-select v-model="level">
                <el-option v-for="diff in diffList" :key="diff" :value="diff">
                </el-option>
              </el-select>
            </el-form-item>
          </template>
          <template v-else>
            <el-upload
              style="margin-left: 100px"
              action="#"
              :auto-upload="false"
              :on-change="handleChange"
              :file-list="initFileList"
              ref=questionUpload>
              <el-button slot="trigger" type="primary">{{ $t('UPLOAD.FILE_ADD') }}</el-button>
            </el-upload>
            <br />
            <!-- 새 유튜브 추가 -->
            <el-form-item :label="$t('NOTE.YOUTUBE')">
              <el-input v-model="youtubeURL" :placeholder="$t('VIDEO.ENTER_URL')"></el-input>
              <youtube
                v-if="youtubeURL !== undefined && youtubeURL !== ''"
                player-width="100%"
                id="video"
                :video-id="youtubeId(youtubeURL)"
                :player-vars="{ autoplay: 1, modestbranding: 1 }"
              />
            </el-form-item>
          </template>

          <br>

          <el-form-item :label="$t('QUESTION.KEYWORD')">
            <div style="width: 50%; margin-bottom: 5px;">
              <el-select v-model="keywordName" :placeholder="$t('QUESTION.KEYWORD')">
                <el-option v-for="key in keyList" :key="key.keyword" :value="key.keyword">
                </el-option>
              </el-select>
            </div>
            <el-select v-model="keywordPoint" :placeholder="$t('LECTURE_MANAGE.ALLOTS')">
              <el-option v-for="pt in pts" :key="pt" :value="pt">
              </el-option>
            </el-select>
            <el-button @click="onClick('ADD_KEYWORD')">{{ $t('LECTURE_MANAGE.ADD') }}</el-button>
            <div v-for="(item, index) in keywordList" :key="item.keyword">
              <el-button>{{ item.keyword }} :: {{item.score_portion }}{{ $t('LECTURE_MANAGE.SCORE') }}</el-button>
              <el-button @click="onClick('DELETE_KEYWORD', index)" type="danger"
              style="margin-bottom: 5px;">X</el-button>
            </div>
          </el-form-item>
          <div class="ps-align-right">
            <el-button type="primary" @click="onCreate">{{ $t('STUDENT_MENU.SUBMIT') }}</el-button>
          </div>
        </div>
      </el-form>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex';
import { getIdFromURL } from 'vue-youtube-embed';
import studentService from '../../services/studentService';

export default {
  data() {
    return {
      isAdd: true,
      questionName: '',
      question: '',
      questionType: null,
      initFileList: [],
      questionList: [],
      choice: [],
      answer: [],
      level: 3,
      diffList: [5, 4, 3, 2, 1],
      keywordName: '',
      keywordPoint: '',
      pts: [5, 4, 3, 2, 1],
      keywordList: [],
      keyList: [],
      value: null,
      youtubeURL: '',
    };
  },
  computed: {
    ...mapState('studentQuestion', ['mode', 'studentQuestionList', 'lectureId']),
    // ...mapState('NNclass',['curLectureId']),
  },
  async mounted() {
    const vm = this;
    const lid = vm.lectureId;
    const res = await studentService.getKeyword({ id: lid });
    for (let i = 0; i < res.data.length; i += 1) {
      vm.keyList.push(res.data[i]);
    }
  },
  methods: {
    ...mapActions('studentQuestion', ['pushQuestion', 'updateStudentQuestionMode1']),
    initialForm() {
      const vm = this;
      vm.level = 3;
      vm.questionName = '';
      vm.question = '';
      vm.questionList = [];
      vm.choice = [];
      vm.answer = [];
      vm.initFileList = [];
      vm.keywordName = '';
      vm.keywordPoint = '';
      vm.keywordList = [];
    },
    youtubeId(URL) {
      return URL !== undefined ? getIdFromURL(URL) : '';
    },
    handleAnswerListChange(val) {
      // alert(val);
      this.answer = val;
    },
    handleChange(file, filelist) {
      const vm = this;
      // file 용량 제한
      vm.initFileList = filelist;
    },
    handleExceed() {
      const vm = this;
      vm.$message.warning(vm.$t('WARNING.MAX_NUMBER_FILE'));
    },
    onAttach() {

    },
    onClick(type, arg) {
      const vm = this;
      switch (type) {
        case 'ADD_ANSWER': {
          vm.answer.push('');
          break;
        }
        case 'DELETE_ANSWER': {
          vm.answer.pop();
          break;
        }
        case 'ADD_KEYWORD': {
          if (vm.keywordName !== '' && vm.keywordPoint !== '') {
            for (let i = 0; i < vm.keywordList.length; i += 1) {
              if (vm.keywordList[i].keyword === vm.keywordName) {
                vm.$notify({
                  title: vm.$t('NOTIFY.TITLE'),
                  message: vm.$t('NOTIFY.ALRDY_REG_KEY'),
                  type: 'warning',
                });
                vm.keywordName = '';
                vm.keywordPoint = '';
                break;
              }
            }
            if (vm.keywordName !== '') {
              vm.keywordList.push({
                keyword: vm.keywordName,
                score_portion: vm.keywordPoint,
              });
              vm.keywordName = '';
              vm.keywordPoint = '';
            }
            break;
          } else {
            vm.$message.warning(vm.$t('NOTIFY.ENTER_KEY_SCORE'));
            break;
          }
        }
        case 'DELETE_KEYWORD': {
          vm.keywordList.splice(arg, 1);
          break;
        }
        default: {
          break;
        }
      }
    },
    async onCreate() {
      const vm = this;
      const lid = vm.lectureId;
      let progress_ok = true;
      // 공통
      if (vm.keywordList.length === 0) { // 키워드 없는 경우
        progress_ok = false;
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('NOTIFY.ENTER_KYWRD'), 
          type: 'warning',
        });
      } else if (vm.questionName === '') { // 제목 없는 경우
        progress_ok = false;
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('NOTIFY.TITLE_REQ'),
          type: 'warning',
        });
      }
      // 파일 첨부일 경우
      if (vm.questionType === '2') {
        if (!(vm.initFileList.length || vm.youtubeURL)) { // 파일을 첨부 안했을 경우
          progress_ok = false;
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('NOTIFY.ATTACH_FILE'),
            type: 'warning',
          });
        } else if (vm.question === '') { // 설명을 입력 안했을 경우
          progress_ok = false;
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('NOTIFY.ENTER_EXP'),
            type: 'warning',
          });
        }
      } else {
        // 단답 + 객관일 경우
        if (vm.answer.length === 0) { // 답이 없는 경우
          progress_ok = false;
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('NOTIFY.ENTER_ANS'),
            type: 'warning',
          });
        }
        if (vm.questionType === '0') {
          if (vm.choice.length < 1) {
            progress_ok = false;
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ENTER_CHO'),
              type: 'warning',
            });
          }
        }
      } 
      if (progress_ok) {
        let res = null;
        if (vm.questionType === '2') {
          // 문제 생성
          res = await studentService.postQuestion({ // 문제 생성?
            id: lid,
            name: vm.questionName,
            question: vm.question,
            type: parseInt(vm.questionType, 10),
            answer: vm.youtubeURL, // 파일은 정답이 없으므로 유튜브 링크를 answer로 대신 제출
          });
          // file post
          for (let i = 0; i < vm.initFileList.length; i += 1) {
            studentService.postFile({
              id: lid,
              qId: res.data.student_question_id,
              file: vm.initFileList[i].raw,
            });
          }
        } else {
          res = await studentService.postQuestion({
            id: lid,
            name: vm.questionName,
            question: vm.question,
            choice: vm.choice,
            answer: vm.answer,
            difficulty: vm.level,
            type: parseInt(vm.questionType, 10),
          });
        }
        if (res) {
          const keywordRes = await studentService.postKeyword({
            id: lid,
            qId: res.data.student_question_id,
            data: vm.keywordList,
          });
          if (keywordRes) {
            vm.pushQuestion({ data: res });
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.SUBMITTED'),
              type: 'success',
            });
            vm.updateStudentQuestionMode1({ mode: 0 });
          }
        } else {
          vm.updateStudentQuestionMode1({ mode: 0 });
        }
      }
    },
  },
};
</script>
<style>
.answer-list {
  width: 250px;
}
</style>